.\"	$NetBSD: sk.4,v 1.12 2008/05/02 18:11:05 martin Exp $
.\"
.\" Copyright (c) 2003, The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\"	$OpenBSD: sk.4,v 1.41 2006/08/16 22:01:56 kettenis Exp $
.\"
.\" Copyright (c) 1997, 1998, 1999
.\"	Bill Paul <wpaul@ctr.columbia.edu>. All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Bill Paul.
.\" 4. Neither the name of the author nor the names of any co-contributors
.\"    may be used to endorse or promote products derived from this software
.\"   without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
.\" THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man4/man4.i386/sk.4,v 1.3 1999/08/28 00:20:29 peter Exp $
.\"
.Dd September 9, 2006
.Dt SK 4
.Os
.Sh NAME
.Nm sk ,
.Nm skc
.Nd SysKonnect XMAC II and Marvell GMAC based gigabit ethernet
.Sh SYNOPSIS
.Cd "skc* at pci? dev ? function ?"
.Cd "sk* at skc?"
.Cd "mskc* at pci? dev ? function ?"
.Cd "msk* at skc?"
.Sh DESCRIPTION
The
.Nm sk
driver provides support for SysKonnect based gigabit ethernet adapters
and Marvell based gigabit ethernet adapters, including the following:
.Pp
.Bl -bullet -offset indent -compact
.It
SK-9821 SK-NET GE-T single port, copper adapter
.It
SK-9822 SK-NET GE-T dual port, copper adapter
.It
SK-9841 SK-NET GE-LX single port, single mode fiber adapter
.It
SK-9842 SK-NET GE-LX dual port, single mode fiber adapter
.It
SK-9843 SK-NET GE-SX single port, multimode fiber adapter
.It
SK-9844 SK-NET GE-SX dual port, multimode fiber adapter
.It
SK-9521 V2.0 single port, copper adapter (32-bit)
.It
SK-9821 V2.0 single port, copper adapter
.It
SK-9843 V2.0 single port, copper adapter
.It
3Com 3c940 single port, copper adapter
.It
Belkin Gigabit Desktop Network PCI Card, single port, copper (32-bit)
.It
D-Link DGE-530T single port, copper adapter
.It
Linksys EG1032v2 single-port, copper adapter
.It
Linksys EG1064v2 single-port, copper adapter
.El
.Pp
The
.Nm msk
driver provides support for the Marvell Yukon-2 based Gigabit Ethernet
adapters, including the following:
.Pp
.Bl -bullet -offset indent -compact
.It
Marvell Yukon 88E8035, copper adapter
.It
Marvell Yukon 88E8036, copper adapter
.It
Marvell Yukon 88E8038, copper adapter
.It
Marvell Yukon 88E8050, copper adapter
.It
Marvell Yukon 88E8052, copper adapter
.It
Marvell Yukon 88E8053, copper adapter
.It
Marvell Yukon 88E8055, copper adapter
.It
SK-9E21 1000Base-T single port, copper adapter
.It
SK-9E22 1000Base-T dual port, copper adapter
.It
SK-9E81 1000Base-SX single port, multimode fiber adapter
.It
SK-9E82 1000Base-SX dual port, multimode fiber adapter
.It
SK-9E91 1000Base-LX single port, single mode fiber adapter
.It
SK-9E92 1000Base-LX dual port, single mode fiber adapter
.It
SK-9S21 1000Base-T single port, copper adapter
.It
SK-9S22 1000Base-T dual port, copper adapter
.It
SK-9S81 1000Base-SX single port, multimode fiber adapter
.It
SK-9S82 1000Base-SX dual port, multimode fiber adapter
.It
SK-9S91 1000Base-LX single port, single mode fiber adapter
.It
SK-9S92 1000Base-LX dual port, single mode fiber adapter
.It
SK-9E21D 1000Base-T single port, copper adapter
.El
.Pp
The SysKonnect based adapters consist of two main components: the
XaQti Corp. XMAC II Gigabit MAC
.Pq Nm sk
and the SysKonnect GEnesis controller ASIC
.Pq Nm skc .
The XMAC provides the Gigabit MAC and PHY support
while the GEnesis provides an interface to the PCI bus, DMA support,
packet buffering and arbitration.
The GEnesis can control up to two XMACs simultaneously,
allowing dual-port NIC configurations.
.Pp
The Marvell based adapters are a single integrated circuit, but are
still presented as a separate MAC
.Pq Nm sk
and controller ASIC
.Pq Nm skc .
At this time, there are no dual-port Marvell based NICs.
.Pp
The
.Nm
driver configures dual port SysKonnect adapters such that each XMAC
is treated as a separate logical network interface.
Both ports can operate independently of each other and can be connected
to separate networks.
The SysKonnect driver software currently only uses the second port on
dual port adapters for failover purposes: if the link
on the primary port fails, the SysKonnect driver will automatically
switch traffic onto the second port.
.Pp
The XaQti XMAC II supports full and half duplex operation with
autonegotiation.
The XMAC also supports unlimited frame sizes.
Support for jumbo frames is provided via the interface MTU setting.
Selecting an MTU larger than 1500 bytes with the
.Xr ifconfig 8
utility configures the adapter to receive and transmit jumbo frames.
Using jumbo frames can greatly improve performance for certain tasks,
such as file transfers and data streaming.
.Pp
Hardware TCP/IP checksum offloading for IPv4 is supported.
.Pp
The following media types and options (as given to
.Xr ifconfig 8 )
are supported:
.Bl -tag -width xxx -offset indent
.It Cm media No autoselect
Enable autoselection of the media type and options.
The user can manually override
the autoselected mode.
.\" by adding media options to the appropriate
.\" .Xr hostname.if 5
.\" file.
.It Cm media No 1000baseSX Cm mediaopt No full-duplex
Set 1000Mbps (Gigabit Ethernet) operation on fiber and force full-duplex mode.
.It Cm media No 1000baseSX Cm mediaopt No half-duplex
Set 1000Mbps (Gigabit Ethernet) operation on fiber and force half-duplex mode.
.It Cm media No 1000baseT Cm mediaopt No full-duplex
Set 1000Mbps (Gigabit Ethernet) operation and force full-duplex mode.
.El
.Pp
For more information on configuring this device, see
.Xr ifconfig 8 .
To view a list of media types and options supported by the card, try
.Ic ifconfig Fl m Aq device .
For example,
.Ic ifconfig Fl m Ar sk0 .
.Sh DIAGNOSTICS
.Bl -diag
.It "sk%d: couldn't map memory"
A fatal initialization error has occurred.
.It "sk%d: couldn't map ports"
A fatal initialization error has occurred.
.It "sk%d: couldn't map interrupt"
A fatal initialization error has occurred.
.It "sk%d: failed to enable memory mapping!"
The driver failed to initialize PCI shared memory mapping.
This might happen if the card is not in a bus-master slot.
.It "sk%d: no memory for jumbo buffers!"
The driver failed to allocate memory for jumbo frames during
initialization.
.It "sk%d: watchdog timeout"
The device has stopped responding to the network, or there is a problem with
the network connection (cable).
.El
.Sh SEE ALSO
.Xr ifmedia 4 ,
.Xr intro 4 ,
.Xr netintro 4 ,
.Xr pci 4 ,
.Xr ifconfig 8
.Rs
.%T XaQti XMAC II datasheet
.%O http://www.xaqti.com
.Re
.Rs
.%T SysKonnect GEnesis programming manual
.%O http://www.syskonnect.com
.Re
.Sh HISTORY
The
.Nm
device driver first appeared in
.Fx 3.0 .
.Ox
support was added in
.Ox 2.6 .
.Nx
support was added in
.Nx 2.0 .
.Pp
The
.Nm msk
driver first appeared in
.Ox 4.0 ,
and was ported to
.Nx 4.0 .
.Sh AUTHORS
.An -nosplit
The
.Nm
driver was written by
.An Bill Paul Aq wpaul@ctr.columbia.edu .
Support for the Marvell Yukon-2 was added by
.An Mark Kettenis Aq kettenis@openbsd.org .
.Sh BUGS
This driver is
.Em experimental .
.Pp
Support for checksum offload is unimplemented.
.Pp
Performance with at least some Marvell-based adapters is poor,
especially on loaded PCI buses or when the adapters are behind
PCI-PCI bridges.
It is believed that this is because the Marvell parts have
significantly less buffering than the original SysKonnect cards
had.
